/* sines.c - noisy sinusoids */

#include <stdio.h>
#include <math.h>

#define L   100
#define f1  0.05
#define f2  0.03
#define A1  5
#define A2  A1

double gran();                     /* gaussian random number generator */

void main()
{
    int n;
    long iseed=2001;               /* gran requires iseed to be long int */
    double y1, y2, mean = 0.0, sigma = 1.0, pi = 4 * atan(1.0);
    FILE *fp1, *fp2;

    fp1 = fopen("y1.dat", "w");           /* open file y1.dat for write */
    fp2 = fopen("y2.dat", "w");           /* open file y2.dat for write */

    for (n=0; n<L; n++) {                /* iseed is passed by address */
        y1 = A1 * cos(2 * pi * f1 * n) + gran(mean, sigma, &iseed);
        y2 = A2 * cos(2 * pi * f2 * n) + gran(mean, sigma, &iseed);
        fprintf(fp1, "%12.6f\n", y1);
        fprintf(fp2, "%12.6f\n", y2);
        }

    fclose(fp1);
    fclose(fp2);
}
